import { Agent } from 'alice-bob';
import { SyncedSet } from 'synced-set';
import { SchedulerEvent, SchedulerEventGroup, SchedulerTarget } from './scheduler-event';
import type { ImmSet } from 'immutable-map-set';
import type { SchedulerProcessor } from './scheduler-processor';
import type { SchedulerTargetNode } from './scheduler-target-node';
export interface SyncedSetPayload {
    targets: ImmSet<SchedulerTarget>;
    events: ImmSet<SchedulerEvent>;
}
export declare class SchedulerNode extends EventTarget {
    context: BaseAudioContext;
    private static registeredCtx;
    static register(context: BaseAudioContext): Promise<void>;
    static create(context: BaseAudioContext): Promise<SchedulerNode>;
    node: AudioWorkletNode;
    worklet: Agent<SchedulerProcessor, SchedulerNode>;
    targetNodes: Set<SchedulerTargetNode>;
    eventGroups: SyncedSet<SchedulerEventGroup, SyncedSetPayload>;
    createEventGroup(): SchedulerEventGroup;
    removeEventGroup(eventGroup: SchedulerEventGroup): void;
    constructor(context: BaseAudioContext);
    start(): Promise<number>;
    stop(): void;
    setBpm(bpm: number): void;
    connect(targetNode: SchedulerTargetNode): SchedulerTargetNode;
    disconnect(targetNode: SchedulerTargetNode): void;
}
