/// <reference types="audioworklet" />
import { SyncedSet } from 'synced-set';
import type { SchedulerEventGroup } from './scheduler-event';
export declare class SchedulerProcessor extends AudioWorkletProcessor {
    blockSize: number;
    private sampleTime;
    private quantumDurationTime;
    private bpm;
    coeff: number;
    playbackStartTime: number;
    adjustedStartTime: number;
    running: boolean;
    eventGroups: SyncedSet<SchedulerEventGroup, null>;
    constructor();
    start(playbackStartTime?: number): Promise<number>;
    stop(): void;
    setBpm(bpm: number): void;
    process(): boolean;
}
